Subject: Re: [PATCH net-next 02/15] net: stmmac: helpers for filling tx_q->tx_skbuff_dma

From: "Russell King (Oracle)" <[email-masked]>
Date: Wed, 11 Mar 2026 14:59:55 +0000

On Wed, Mar 11, 2026 at 03:57:13PM +0100, Andrew Lunn wrote:
> On Wed, Mar 11, 2026 at 09:52:14AM +0000, Russell King (Oracle) wrote:
> > Add helpers to fill in the transmit queue metadata to ensure that all
> > entries are initialised when preparing to transmit. This avoids clean
> > up code running into surprises.
> > 
> > For example, stmmac_clean_desc3() (which calls clean_desc3() in
> > chain_mode.c or ring_mode.c) looks at the .last_segment, and in the
> > latter case, .is_jumbo members.
> > 
> > stmmac_tso_xmit() was also a problem. If the metadata is not fully
> > cleared when cleaning dirty entries (or, in the case of resume,
> > freeing all entries) then .last_segment may be left set, which then
> > causes:
> > 
> >         stmmac_prepare_tso_tx_desc(priv, first, 1, proto_hdr_len, 0, 1,
> >                                    tx_q->tx_skbuff_dma[first_entry].last_segment+,
> >                                    hdr / 4, (skb->len - proto_hdr_len));
> > 
> > to mark the
> 
> That sentence appear to be unfinished.

Hmm, it's also not relevant anymore because we fixed that problem in a
different way.

-- 
RMK's Patch system: https://www.armlinux.org.uk/developer/patches/
FTTP is here! 80Mbps down 10Mbps up. Decent connectivity at last!